--AsmoMOD made by Asmodius, Arthas Server
--All rights reserved.

-- Declare Needed Variables
AsmoMOD_UpdateInterval = 1.0;
local TimeSinceLastUpdate = 0;
local bgtime = -1;
local reztime = -1;
local sumtime = -1;
local manastart = 999;
local AsmoMOD_Color = "|c000566FF";
local AsmoMOD_ColorR = "|c00FF0000";
local RipID = 0;
local RipAction = 0;
local opID = 0;
local opAction = 0;
local berID = 0;
local berAction = 0;
local rejuvID = 0;
local rejuvAction = 0;
local regID = 0;
local regAction = 0;
local swiftID = 0;
local WotfID = 0;
local healID = 0;
local LightID = 0;
local touchID = 0;
local feignID = 0;
local trapID = 0;
local nsID = 1;
local escapeID = 0;
local inCombat = false;
local herbID = 0;
local mineID = 0;
local nshealme = 0;
local SaveMe = 0;
local UntangleMe = 0;
local CureMe = 0;
local herbmineme = 0;
local swiftme = -1;
local emerlist = -1;
local emerme = 0;
local nslightning = 0;
local feigntrap = 0;
local justenabled = 0;
local rejuvcheck = false;
local growthcheck = false;
local FullStormrage = 0;
local nametoadd = nil;
local resetcounter = 0;
local rejuvtoadd;
local regtoadd;
local AsmoMODOptionsButton_BeingDragged = false;

-- Show the Option Menu
function AsmoMOD_showMenu()
	PlaySound("igMainMenuOpen");
	AsmoMODOptions:Show();
end

-- Load Event
function AsmoMOD_OnLoad()

	this.TimeSinceLastUpdate = 0;
	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	this:RegisterEvent("PLAYER_DEAD");
	this:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
        this:RegisterEvent("MERCHANT_SHOW");
	this:RegisterEvent("RESURRECT_REQUEST");
	this:RegisterEvent("CONFIRM_SUMMON");
	this:RegisterEvent("PARTY_INVITE_REQUEST");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PLAYER_CONTROL_LOST");
	this:RegisterEvent("PLAYER_CONTROL_GAINED");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_SELF");
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("PLAYER_UNGHOST");
	this:RegisterEvent("SPELLCAST_START");
	this:RegisterEvent("SPELLCAST_STOP");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("BAG_UPDATE");
	AsmoMOD_Chat("AsmoMOD v1.90 loaded.");

	if (AsmoMOD_Save == nil) then
		AsmoMOD_LoadDefaultVars();
	elseif (AsmoMOD_Save.conservedelay == nil) then
		AsmoMOD_ChatR("Previous version below v1.90 detected, resetting options");
		AsmoMOD_LoadDefaultVars();
	end	

	SLASH_Asmo1 = "/Asmo";
	SlashCmdList["Asmo"] = AsmoMOD_showMenu;

	SLASH_nsheal1 = "/nsheal";
	SlashCmdList["nsheal"] = AsmoMOD_nsheal;

	SLASH_nslight1 = "/nslight";
	SlashCmdList["nslight"] = AsmoMOD_nslight;

	SLASH_feigntrap1 = "/feigntrap";
	SlashCmdList["feigntrap"] = AsmoMOD_feigntrap;

	SLASH_timer1 = "/timer";
	SlashCmdList["timer"] = ExecuteCheck;

	-- Add my options frame to the global UI panel list
	UIPanelWindows["AsmoMODOptions"] = {area = "center", pushable = 1};

end	

-- Event Handler	
function AsmoMOD_OnEvent(event)
	
	-- Load Base Variables and Auto-Cast find herbs/minerals
	if (event == "PLAYER_ENTERING_WORLD") then
		AsmoMOD_Load();
		if(AsmoMOD_Save.herbmineenabled) then
			herbmineme = 1;
		end
	end

	-- Determine if player is in combat
	if (event == "PLAYER_REGEN_ENABLED") then 
		inCombat = false;
	end
	if (event == "PLAYER_REGEN_DISABLED") then 
		inCombat = true;
	end

	-- Auto-release to the GY
	if ( event == "PLAYER_DEAD" ) then
		AsmoMOD_Release();
	end

	-- Auto-join the BG when its your turn
	if ( event == "UPDATE_BATTLEFIELD_STATUS" ) then
		if( AsmoMOD_Save.bgjoinenabled ) then
			for i=1, MAX_BATTLEFIELD_QUEUES do
				local status, _, _ = GetBattlefieldStatus(i);
				if (status == "confirm") then
					if(AsmoMOD_Save.bgtime == 0) then
						AsmoMOD_bgJoin();
					else
						bgtime = AsmoMOD_Save.bgtime;
						AsmoMODBGTime:SetText(AsmoMOD_Save.bgtime);
						AsmoMODBGChoice:Show();
					end
				end
			end
		end
	end

	-- Auto-Repair when you see a merchant
	if ( event == "MERCHANT_SHOW") then
		AsmoMOD_RepairInventory();
		AsmoMOD_RepairEquipment();
	end		

	-- Auto-Ressurect
	if ( event == "RESURRECT_REQUEST" ) then
		if(AsmoMOD_Save.rezenabled) then
			if(AsmoMOD_Save.reztime == 0) then
				AsmoMOD_Resurrect();
			else
				reztime = AsmoMOD_Save.reztime;
				AsmoMODRessTime:SetText(AsmoMOD_Save.reztime);
				AsmoMODRessChoice:Show();
			end
		end
	end
	
	-- Auto-Summon
	if ( event == "CONFIRM_SUMMON" ) then
		if(AsmoMOD_Save.summonenabled) then
			if(AsmoMOD_Save.sumtime == 0) then
				AsmoMOD_Summon();
			else
				sumtime = AsmoMOD_Save.sumtime;
				AsmoMODSummTime:SetText(AsmoMOD_Save.sumtime);
				AsmoMODSummChoice:Show();
			end
		end
	end

	-- Auto-Group
	if (event == "PARTY_INVITE_REQUEST") then
		AsmoMOD_Group();
	end

	-- Restore Control Fear
	if (event == "PLAYER_CONTROL_GAINED") then 
		SaveMe = 0;
	end

	-- Do not fear if entering/leaving a BG
	if (event == "ZONE_CHANGED_NEW_AREA") then
		SaveMe = 0;
	end

	-- Auto-Trinket Fear Detect
	if (event == "PLAYER_CONTROL_LOST") then 
		if(not GetBattlefieldWinner()) then
			SaveMe = 1;
		end
	end
	
	-- Auto-Trinket Charm/Entangle/Immobilization Detect
	if(event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then
		if(arg1 == "You are afflicted by Seduction.") then
			SaveMe = 1;
		elseif(arg1 == "You are afflicted by Intimidating Shout.") then
			SaveMe = 1;
		elseif(arg1 == "You are afflicted by Entangling Roots.") then
			UntangleMe = 1;
		elseif(arg1 == "You are afflicted by Frost Nova.") then
			UntangleMe = 1;
		elseif(arg1 == "You are afflicted by Crippling Poison.") then
			CureMe = 1;
		elseif(arg1 == "You are afflicted by Hamstring.") then
			CureMe = 1;
		end
	end
		
	-- Restore Control Charm/Entangle/Immobilization
	if(event == "CHAT_MSG_SPELL_AURA_GONE_SELF") then
		if(arg1 == "Seduction fades from you.") then
			SaveMe = 0;
		elseif(arg1 == "Intimidating Shout fades from you.") then
			SaveMe = 0;
		elseif(arg1 == "Entangling Roots fades from you.") then
			UntangleMe = 0;
		elseif(arg1 == "Frost Nova fades from you.") then
			UntangleMe = 0;
		elseif(arg1 == "Crippling Poison fades from you.") then
			CureMe = 0;
		elseif(arg1 == "Hamstring fades from you.") then
			CureMe = 0;
		end
	end

	-- Auto-NSheal
	if(event == "UNIT_HEALTH") then
		--Check to see if the player is below nspercent
 		local ppercent;
		ppercent = (UnitHealth("player") / UnitHealthMax("player")) * 100;
		if(AsmoMOD_Save.nsenabled) then
			if(ppercent <= AsmoMOD_Save.nspercent) then
				nshealme = 1;
			else
				nshealme = 0;
			end
		end
		if(AsmoMOD_Save.emerswiftenabled) then
			if(ppercent <= AsmoMOD_Save.emerpercent) then
				emerme = 1;
			else
				emerme = 0;
			end
		end
	end

	-- Auto-Herb/Mine
	if((event == "PLAYER_UNGHOST") and AsmoMOD_Save.herbmineenabled) then
		herbmineme = 1;
	end

	-- Player Target Changed Hook
	if(event == "PLAYER_TARGET_CHANGED") then
		ExecuteCheck();
	end

	-- Detect Regrowth Casts
	if(event == "CHAT_MSG_SPELL_SELF_BUFF") then
		if(string.find(arg1, "Your Regrowth") ~= nil) then
			if(UnitName("target") == nil) then
				regtoadd = UnitName("player");
				nametoadd = UnitName("player");
			else
				nametoadd = UnitName("target");
				regtoadd = UnitName("target");
			end
			growthcheck = true;
			resetcounter = 0;
		end
	end

	-- Detect if they have added/removed full Stormrage
	if((event == "BAG_UPDATE") and (AsmoMOD_Save.monitorenabled) and (UnitClass("player") == "Druid")) then
		FullStormrage = 3;
		local link = GetInventoryItemLink("player", 1);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Cover") == nil) then
			FullStormrage = 0;
		end
		link = GetInventoryItemLink("player", 3);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Pauldrons") == nil) then
			FullStormrage = 0;
		end
		link = GetInventoryItemLink("player", 5);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Chestguard") == nil) then
			FullStormrage = 0;
		end
		link = GetInventoryItemLink("player", 6);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Belt") == nil) then
			FullStormrage = 0;
		end
		link = GetInventoryItemLink("player", 7);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Legguards") == nil) then
			FullStormrage = 0;
		end
		link = GetInventoryItemLink("player", 8);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Boots") == nil) then
			FullStormrage = 0;
		end
		link = GetInventoryItemLink("player", 9);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Bracers") == nil) then
			FullStormrage = 0;
		end
		link = GetInventoryItemLink("player", 10);
		if(link == nil) then
			FullStomrage = 0;
		elseif(string.find(link, "Stormrage Handguards") == nil) then
			FullStormrage = 0;
		end
	end

	-- Mana Conserve Detect
	if((event == "SPELLCAST_START") and (AsmoMOD_Save.conserveenabled)) then
		if((UnitIsFriend("target", "player")) and AsmoMOD_Save.conservedelay ~= 0) then
			manastart = GetTime() + arg2 / 1000 - AsmoMOD_Save.conservedelay;
		elseif((UnitIsFriend("target", "player")) and AsmoMOD_Save.conservedelay == 0) then
			manastart = 0;
		end
	end

	-- Stop Conserve on Spellcast Cancel or Finish
	if((event == "SPELLCAST_STOP") and (AsmoMOD_Save.conserveenabled)) then
		manastart = 0;
	end
end	

-- Load Needed Variables
function AsmoMOD_Load()

	--If users switching between accounts, protect nil errors
	if (AsmoMOD_Save == nil) then
		AsmoMOD_LoadDefaultVars();
	elseif (AsmoMOD_Save.conservedelay == nil) then
		AsmoMOD_ChatR("Previous version below v1.90 detected, resetting options");
		AsmoMOD_LoadDefaultVars();
	end

	-- Find all spell IDs
	local a = 1
	while true do
		local spellName, spellRank = GetSpellName(a, BOOKTYPE_SPELL)
		if not spellName then
      			do break end
   		end

		-- Find Riposte ID
		if (spellName == "Riposte") then
			texture = GetSpellTexture(a, BOOKTYPE_SPELL)
			RipID = a
			-- Find Action Bar Number for Riposte
			local j;
			for j=1,72, 1 do
				if ( HasAction(j) ) then
					local actiontexture = GetActionTexture(j);
					if ( actiontexture == texture ) then
						RipAction = j
						do break end
					end	
				end
			end
		end

		-- Find Overpower ID
		if (spellName == "Overpower") then
			texture = GetSpellTexture(a, BOOKTYPE_SPELL)
			opID = a
			-- Find Action Bar Number for Overpower
			local j;
			for j=1,108, 1 do
				if ( HasAction(j) ) then
					local actiontexture = GetActionTexture(j);
					if ( actiontexture == texture ) then
						opAction = j
						do break end
					end	
				end
			end
		end	

		-- Find Berserker Rage ID
		if (spellName == "Berserker Rage") then
			texture = GetSpellTexture(a, BOOKTYPE_SPELL)
			berID = a
			-- Find Action Bar Number for Berserker Rage
			local j;
			for j=1,108, 1 do
				if ( HasAction(j) ) then
					local actiontexture = GetActionTexture(j);
					if ( actiontexture == texture ) then
						berAction = j
						do break end
					end	
				end
			end
		end

		-- Find Regrowth ID
		if (spellName == "Regrowth") then
			texture = GetSpellTexture(a, BOOKTYPE_SPELL)
			regID = a
			-- Find Action Bar Number for Regrowth
			local j;
			for j=1,108, 1 do
				if ( HasAction(j) ) then
					local actiontexture = GetActionTexture(j);
					if ( actiontexture == texture ) then
						regAction = j
						do break end
					end	
				end
			end
		end

		-- Find Rejuvenation ID
		if (spellName == "Rejuvenation") then
			texture = GetSpellTexture(a, BOOKTYPE_SPELL)
			rejuvID = a
			-- Find Action Bar Number for Rejuvenation
			local j;
			for j=1,108, 1 do
				if ( HasAction(j) ) then
					local actiontexture = GetActionTexture(j);
					if ( actiontexture == texture ) then
						rejuvAction = j
						do break end
					end	
				end
			end
		end
	
		-- Find Swiftmend
		if (spellName == "Swiftmend") then
			swiftID = a
		end
		
		-- Find Will of the Forsaken
		if (spellName == "Will of the Forsaken") then
			WotfID = a
		end

		-- Find Healing Wave ID
		if (spellName == "Healing Wave") then
			healID = a
		end

		-- Find Chain Lightning ID
		if (spellNamed == "Chain Lightning") then
			LightID = a
		end

		--Find Healing Touch
		if (spellName == "Healing Touch") then
			touchID = a	
		end
	
		-- Find NS for Shaman and Druid
		if (spellName == "Nature's Swiftness") then
			nsID = a
		end

		-- Find Feign ID
		if (spellName == "Feign Death") then
			feignID = a
		end

		-- Find Trap ID
		if (spellName == "Freezing Trap") then
			trapID = a
		end

		-- Find Herb ID
		if (spellName == "Find Herbs") then
			herbID = a
		end

		-- Find Minerals ID
		if (spellName == "Find Minerals") then
			mineID = a
		end
	
		-- Escape Artist ID
		if(spellName == "Escape Artist") then
			escapeID = a
		end

		a = a + 1;
	end

	-- Correct options frame to saved values
	if(AsmoMOD_Save.bgrelenabled) then
		bgrelenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.bgjoinenabled) then
		bgjoinenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.rezenabled) then
		RessEnabled:SetChecked(1);
	end
	if(AsmoMOD_Save.summonenabled) then
		SummonEnabled:SetChecked(1);
	end
	if(AsmoMOD_Save.repairenabled) then
		repairenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.groupenabled) then
		groupenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.trinketenabled) then
		trinketenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.riposteenabled) then
		riposteenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.nsenabled) then
		nshealenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.executeenabled) then
		executeenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.conserveenabled) then
		conserveenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.herbmineenabled) then
		herbmineenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.overpowerenabled) then
		openabled:SetChecked(1);
	end
	if(AsmoMOD_Save.fearenabled) then
		fearenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.entangleenabled) then
		entangleenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.impairenabled) then
		impairenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.wotfenabled) then
		wotfenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.escapeenabled) then
		escapeenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.zerkenabled) then
		zerkenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.autoswiftenabled) then
		autoswiftenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.emerswiftenabled) then
		emerswiftenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.monitorenabled) then
		swiftmonitorenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.monitorenabled) then
		swiftmonitorenabled:SetChecked(1);
	end
	if(AsmoMOD_Save.playerswiftonenabled) then
		playerswiftonenabled:SetChecked(1);
	end
	nshealpercentage:SetValue(AsmoMOD_Save.nspercent);
	conservepercentage:SetValue(AsmoMOD_Save.conservepercent);
	swiftpercent:SetValue(AsmoMOD_Save.swiftpercent);
	emerpercent:SetValue(AsmoMOD_Save.emerpercent);
	restimer:SetValue(AsmoMOD_Save.reztime);
	bgtimer:SetValue(AsmoMOD_Save.bgtime);
	summontimer:SetValue(AsmoMOD_Save.sumtime);
	conservetime:SetValue(AsmoMOD_Save.conservedelay);
end

-- Cast spells
function ExecuteCheck()

	-- Auto-PvP Trinket and WoTF and Berserker Rage for sleep/charm/stun/fear
	if ((AsmoMOD_Save.trinketenabled) and (UnitOnTaxi("player") ~= 1) and (SaveMe == 1) and (AsmoMOD_Save.fearenabled)) then

		-- Use Berserker Rage if it is active
		if ((UnitClass("player") == "Warrior") and (AsmoMOD_Save.zerkenabled)) then
			local duration = GetSpellCooldown(berID, 1);
			if((duration == 0) and IsUsableAction(berAction)) then 
				CastSpell(berID, BOOKTYPE_SPELL);
			end
		end

		-- Use WoTF if it is active
		if ((UnitRace("player") == "Undead") and (AsmoMOD_Save.wotfenabled)) then
			local duration = GetSpellCooldown(WotfID, 1);
			if(duration == 0) then 
				CastSpell(WotfID, BOOKTYPE_SPELL);
			end
		end

		-- Use PvP Trinket if it is equipped and active
		myTrinket0 =  GetInventoryItemLink("player", GetInventorySlotInfo("Trinket0Slot"))
		myTrinket1 =  GetInventoryItemLink("player", GetInventorySlotInfo("Trinket1Slot"))

		if (myTrinket0 == nil) then myTrinket0 = "empty" end
		if (myTrinket1 == nil) then myTrinket1 = "empty" end
			
		if ((string.find(myTrinket0, "Insignia of the Horde") ~= nil) or (string.find(myTrinket0, "Insignia of the Alliance") ~= nil)) then
			myTrinketUse = GetInventorySlotInfo("Trinket0Slot")
		elseif ((string.find(myTrinket1, "Insignia of the Horde") ~= nil) or (string.find(myTrinket1, "Insignia of the Alliance") ~= nil)) then
			myTrinketUse = GetInventorySlotInfo("Trinket1Slot")
		else
			myTrinketUse = nil
		end
		if(myTrinketUse ~= nil) then
			UseInventoryItem(myTrinketUse);
		end
	end

	-- Auto-PvP Trinket and Escape Artist for entanglement effects
	if ((AsmoMOD_Save.trinketenabled) and (UntangleMe == 1) and (AsmoMOD_Save.entangleenabled)) then

		-- Use Escape Artist if it is active
		if (UnitRace("player") == "Gnome") then
			local duration = GetSpellCooldown(escapeID, 1);
			if(duration == 0) then 
				CastSpell(escapeID, BOOKTYPE_SPELL);
			end
		end

		-- Use PvP Trinket if it is equipped and active and it is a PvP trinket 
		--that can dispell entangling effects
		if ((UnitClass("player") == "Warrior") or (UnitClass("player") == "Hunter") or (UnitClass("player") == "Shaman")) then
			myTrinket0 =  GetInventoryItemLink("player", GetInventorySlotInfo("Trinket0Slot"))
			myTrinket1 =  GetInventoryItemLink("player", GetInventorySlotInfo("Trinket1Slot"))

			if (myTrinket0 == nil) then myTrinket0 = "empty" end
			if (myTrinket1 == nil) then myTrinket1 = "empty" end
			
			if ((string.find(myTrinket0, "Insignia of the Horde") ~= nil) or (string.find(myTrinket0, "Insignia of the Alliance") ~= nil)) then
				myTrinketUse = GetInventorySlotInfo("Trinket0Slot")
			elseif ((string.find(myTrinket1, "Insignia of the Horde") ~= nil) or (string.find(myTrinket1, "Insignia of the Alliance") ~= nil)) then
				myTrinketUse = GetInventorySlotInfo("Trinket1Slot")
			else
				myTrinketUse = nil
			end
			if(myTrinketUse ~= nil) then
				UseInventoryItem(myTrinketUse);
			end
		end
	end

	-- Auto-PvP Trinket for impairment effects
	if ((AsmoMOD_Save.trinketenabled) and (CureMe == 1) and (AsmoMOD_Save.impairenabled)) then

		-- Use Escape Artist if it is active
		if (UnitRace("player") == "Gnome") then
			local duration = GetSpellCooldown(escapeID, 1);
			if(duration == 0) then 
				CastSpell(escapeID, BOOKTYPE_SPELL);
			end
		end

		-- Use PvP Trinket if it is equipped and active and it is a PvP trinket 
		--that can dispell entangling effects
		if ((UnitClass("player") == "Hunter")) then
			myTrinket0 =  GetInventoryItemLink("player", GetInventorySlotInfo("Trinket0Slot"))
			myTrinket1 =  GetInventoryItemLink("player", GetInventorySlotInfo("Trinket1Slot"))

			if (myTrinket0 == nil) then myTrinket0 = "empty" end
			if (myTrinket1 == nil) then myTrinket1 = "empty" end
			
			if ((string.find(myTrinket0, "Insignia of the Horde") ~= nil) or (string.find(myTrinket0, "Insignia of the Alliance") ~= nil)) then
				myTrinketUse = GetInventorySlotInfo("Trinket0Slot")
			elseif ((string.find(myTrinket1, "Insignia of the Horde") ~= nil) or (string.find(myTrinket1, "Insignia of the Alliance") ~= nil)) then
				myTrinketUse = GetInventorySlotInfo("Trinket1Slot")
			else
				myTrinketUse = nil
			end
			if(myTrinketUse ~= nil) then
				UseInventoryItem(myTrinketUse);
			end
		end
	end

	-- Auto-Riposte
	if(AsmoMOD_Save.riposteenabled and (UnitClass("player") == "Rogue")) then
		duration = GetSpellCooldown(RipID, 1);
		if(IsUsableAction(RipAction) and (duration == 0)) then
			CastSpellByName("Riposte");
		end
	end

	-- Auto-Overpower
	if(AsmoMOD_Save.overpowerenabled and (UnitClass("player") == "Warrior")) then
		duration = GetSpellCooldown(opID, 1);
		if(IsUsableAction(opAction) and (duration == 0)) then
				CastSpellByName("Overpower");
		end
	end

	-- Auto-Execute
	if((AsmoMOD_Save.executeenabled) and (UnitClass("player") == "Warrior")) then
		--Check to see if the target is at 20% or less
		local tpercent;
		tpercent = (UnitHealth("target") / UnitHealthMax("target")) * 100;
		if(tpercent <= 20) then
			if(UnitMana("player") >= 15) then 
				CastSpellByName("Execute");
			end
		end
	end

	-- Auto-NSheal
	if((nshealme >= 1) and (AsmoMOD_Save.nsenabled)) then
		duration = GetSpellCooldown(nsID, 1);
		if(duration == 0) then 
			CastSpellByName("Nature's Swiftness");
		end
		SpellStopCasting();
		local i = 1;
		local nsup = false;
		while true do
			buff = UnitBuff("player", i);
			if not buff then
      				do break end;
   			end
			if(string.find(buff, "Spell_Nature_RavenForm") ~= nil) then
				nsup = true;
			end
			i = i + 1;
		end
		if(nsup == false) then
			return;
		end
		if((UnitClass("player") == "Druid")) then
			duration = GetSpellCooldown(touchID, 1);
			if(duration == 0) then 
				if(UnitIsEnemy("target", "player")) then
					local onPlayer = 0;
					if(UnitName("player") == UnitName("target")) then
						onPlayer = 1;
					end
					TargetUnit("player");
					CastSpellByName("Healing Touch");
					if(onPlayer == 0) then
						TargetLastTarget();
					end
					if (UnitIsDead("target")) then
						TargetNearestEnemy()
					end
				else
					TargetUnit("player");
					CastSpellByName("Healing Touch");
				end
			end
		elseif((UnitClass("player") == "Shaman")) then
			duration = GetSpellCooldown(healID, 1);
			if(duration == 0) then 
				if(UnitIsEnemy("target", "player")) then
					local onPlayer = 0;
					if(UnitName("player") == UnitName("target")) then
						onPlayer = 1;
					end
					TargetUnit("player");
					CastSpellByName("Healing Wave");
					if(onPlayer == 0) then
						TargetLastTarget();
					end
					if (UnitIsDead("target")) then
						TargetNearestEnemy()
					end
				else
					TargetUnit("player");
					CastSpellByName("Healing Wave");
				end
			end
		end
	end	

	-- Mana Conserve
	if(AsmoMOD_Save.conserveenabled and UnitIsFriend("target", "player") and (manastart == 0)) then		
		local cpercent;
		cpercent = (UnitHealth("target") / UnitHealthMax("target")) * 100;
		if(cpercent >= AsmoMOD_Save.conservepercent) then
			SpellStopCasting();
			manastart = 999;
		end
	end

	-- Auto-Find herbs/minerals
	if(AsmoMOD_Save.herbmineenabled and herbmineme == 1) then
		local _, _, instanceID = GetBattlefieldStatus(1);
		if ( instanceID == 0 ) and (not UnitOnTaxi("player")) and (not UnitIsDeadOrGhost("player")) and (not inCombat)  then
			if(herbID ~= 0) then
				CastSpellByName("Find Herbs");
			end
			if(mineID ~= 0) then
				CastSpellByName("Find Minerals");
			end
			herbmineme = 0;
		end
	end

	-- Swiftmend Conserve
	if((AsmoMOD_Save.autoswiftenabled) and (swiftme ~= -1) and (swiftID ~= 0)) then
		duration = GetSpellCooldown(swiftID, 1);
		if(duration == 0) then
			local ontar = 0;
			local castbari = getglobal("Asmo_ECB_"..swiftme);
			if(castbari.endTime ~= nil) then
				if(not UnitIsDead(castbari.tindex)) then
					if(UnitName("target") == castbari.name) then
						ontar = 1;
					else
						TargetByName(castbari.name);
					end
					if((not UnitIsDead("target"))) then
						CastSpellByName("Swiftmend");
					end
					if(ontar == 0) then
						TargetLastTarget();
					end
				end
				AsmoMOD_SwiftRemove(castbari.name, swiftme, false);
				swiftme = -1;
			else
				swiftme = -1;
			end
		end
	end

	-- Auto-Emergency Swiftmend Player Only
	if((emerme == 1) and (AsmoMOD_Save.emerswiftenabled) and (swiftID ~= 0)) then
		duration = GetSpellCooldown(swiftID, 1);
		if(duration == 0) then 
			if(UnitIsDead("player")) then
				emerme = 0;
			else
				local i = 1;
				local hotup = false;
				while true do
					buff = UnitBuff("player", i);
					if not buff then
      						do break end;
   					end
					if((string.find(buff, "Spell_Nature_Rejuvenation") ~= nil) or (string.find(buff, "Spell_Nature_ResistNature") ~= nil)) then
						hotup = true;
					end
					i = i + 1;
				end
				if(hotup) then
					local ontar = 0;
					if(UnitName("target") == UnitName("player")) then
						ontar = 1;
					else
						TargetUnit("player");
					end
					CastSpellByName("Swiftmend");
					if(ontar == 0) then
						TargetLastTarget();
					end
				end
				emerme = 0;
			end
		end
	end

	-- Auto-Emergency Swiftmend Non-Player
	if((AsmoMOD_Save.emerswiftenabled) and (emerlist ~= -1) and (not AsmoMOD_Save.playerswiftonenabled) and (SwiftID ~= 0)) then
		duration = GetSpellCooldown(swiftID, 1);
		if(duration == 0) then
			local castbari = getglobal("Asmo_ECB_"..emerlist);
			local ontar = 0;
			if(not UnitIsDead(castbari.tindex)) then
				if(UnitName("target") == castbari.name) then
					ontar = 1;
				else
					TargetByName(castbari.name);
				end
				if((not UnitIsDead("target"))) then
					CastSpellByName("Swiftmend");
				end
				if(ontar == 0) then
					TargetLastTarget();
				end
			end
			AsmoMOD_SwiftRemove(castbari.name, emerlist, false);
			emerlist = -1;
		end
	end
end

-- Auto-Release Implimentation
function AsmoMOD_Release()
	if( AsmoMOD_Save.bgrelenabled ) then
		for i=1, MAX_BATTLEFIELD_QUEUES do
			local _, _, instanceID = GetBattlefieldStatus(i);
			if ( instanceID ~= 0 ) then
				RepopMe();
			end
		end
	end
end

-- Auto-Join BG Implimentation
function AsmoMOD_bgJoin()
	for i=1, MAX_BATTLEFIELD_QUEUES do
		local status, _, _ = GetBattlefieldStatus(i);
		if (status == "confirm") then
			PlaySoundFile("Sound\\Doodad\\BellTollAlliance.wav");
			AcceptBattlefieldPort(i, 1);
			getglobal("StaticPopup1"):Hide();
		end	
	end
end

-- Auto-Ressurect Implimentation
function AsmoMOD_Resurrect()
	AcceptResurrect();
	getglobal("StaticPopup1"):Hide();
end

-- Auto-Repair Equipment Implimentation
function AsmoMOD_RepairEquipment()
	if( (AsmoMOD_Save.repairenabled) and (CanMerchantRepair()) ) then
		RepairAllItems();	
	end
end

-- Auto-Repair Inventory Implimentation
function AsmoMOD_RepairInventory()
	if( (AsmoMOD_Save.repairenabled) and (CanMerchantRepair()) ) then
		local total = GetRepairAllCost();
		total = total + AsmoMOD_GetInventoryCost();
		total = total / 10000;
		AsmoMOD_Chat("All items repaired. Total Cost: " .. total .. " gold.");

		ShowRepairCursor();
		for bag = 0,4,1 do	
			for slot = 1, GetContainerNumSlots(bag) , 1 do
				local hasCooldown, repairCost = GameTooltip:SetBagItem(bag,slot);
				if (repairCost and repairCost > 0) then
					UseContainerItem(bag,slot);
				end
			end
		end
		HideRepairCursor();	
	end
end

-- Get Cost of Repairing Inventory
function AsmoMOD_GetInventoryCost()
	
	local AsmoMOD_InventoryCost = 0;

	for bag = 0,4,1 do	
		for slot = 1, GetContainerNumSlots(bag) , 1 do
			local hasCooldown, repairCost = GameTooltip:SetBagItem(bag,slot);
			if (repairCost) then
				AsmoMOD_InventoryCost = AsmoMOD_InventoryCost + repairCost;
			end
		end
	end

	return AsmoMOD_InventoryCost;
end

-- Auto-Join Group Implimentation
function AsmoMOD_Group()
	if( AsmoMOD_Save.groupenabled ) then
		AcceptGroup();
		AsmoMOD_HideWindow("PARTY_INVITE");
	end
end

-- Automatic Accept Summon Implimentation
function AsmoMOD_Summon()
	ConfirmSummon();
	getglobal("StaticPopup1"):Hide();
end

-- NS-Heal Start
function AsmoMOD_nsheal()
	duration = GetSpellCooldown(nsID, 1);
	if(duration == 0) then 
		CastSpellByName("Nature's Swiftness")
	end
	SpellStopCasting();
	if((UnitClass("player") == "Druid")) then
		duration = GetSpellCooldown(touchID, 1);
		if(duration == 0) then 
			if(UnitIsEnemy("target", "player")) then
				local onPlayer = 0;
				if(UnitName("player") == UnitName("target")) then
					onPlayer = 1;
				end
				TargetUnit("player");
				CastSpellByName("Healing Touch");
				if(onPlayer == 0) then
					TargetLastTarget();
				end
				if (UnitIsDead("target")) then
					TargetNearestEnemy();
				end
			elseif(UnitIsFriend("target", "player")) then
				CastSpellByName("Healing Touch");
			else
				TargetUnit("player");
				CastSpellByName("Healing Touch");
			end
		end
	elseif((UnitClass("player") == "Shaman")) then
		duration = GetSpellCooldown(healID, 1);
		if(duration == 0) then 
			if(UnitIsEnemy("target", "player")) then
				local onPlayer = 0;
				if(UnitName("player") == UnitName("target")) then
					onPlayer = 1;
				end
				TargetUnit("player");
				CastSpellByName("Healing Wave");
				if(onPlayer == 0) then
					TargetLastTarget();
				end
				if (UnitIsDead("target")) then
					TargetNearestEnemy();
				end
			elseif(UnitIsFriend("target", "player")) then
				CastSpellByName("Healing Wave");
			else
				TargetUnit("player");
				CastSpellByName("Healing Wave");
			end
		end
	end
end

-- NS Lightning Start
function AsmoMOD_nslight()
	duration = GetSpellCooldown(nsID, 1);
	if(duration == 0) then 
		CastSpellByName("Nature's Swiftness")
		nslightning = 1;
	end
	SpellStopCasting();
	duration = GetSpellCooldown(LightID, 1);
	if(duration == 0) then 
		if(nslightning == 2) then
			nslightning = 0;
			return;
		end
		nslightning = 2;
		if(UnitIsEnemy("target", "player")) then
			CastSpellByName("Chain Lightning");
		else
			TargetNearestEnemy();
			CastSpellByName("Chain Lightning");
		end
	end
end

-- Feign-Trap Start
function AsmoMOD_feigntrap()
	PetFollow();
	duration = GetSpellCooldown(feignID, 1);
	if(duration == 0) then 
		CastSpellByName("Feign Death")
		feigntrap = 1;
	end
	SpellStopCasting();
	duration = GetSpellCooldown(trapID, 1);
	if(duration == 0) then 
		if(feigntrap == 2) then
			feigntrap = 0;
			return;
		end
		feigntrap = 2;
		CastSpellByName("Freezing Trap");
	end
end

-- Hide Popupbox Implimentation
function AsmoMOD_HideWindow(windowToHide)
	local windowIndex
		for windowIndex = 1, STATICPOPUP_NUMDIALOGS do
			local currentFrame = getglobal("StaticPopup" .. windowIndex)
				if currentFrame:IsVisible() and (currentFrame.which == windowToHide) then
					currentFrame:Hide();
				end
		end
end

-- Basic Text send function
function AsmoMOD_Chat(text)
	DEFAULT_CHAT_FRAME:AddMessage(AsmoMOD_Color..text);
end

function AsmoMOD_ChatR(text)
	DEFAULT_CHAT_FRAME:AddMessage(AsmoMOD_ColorR..text);
end

--Options Functions
function AsmoMODOptionsButton_OnDragStart()
	if (not AsmoMODOptionsButton_BeingDragged) then
		AsmoMOD_Button:StartMoving();
		AsmoMODOptionsButton_BeingDragged = true;
	end
end

function AsmoMODOptionsButton_OnDragStop()
	if (AsmoMODOptionsButton_BeingDragged) then
		AsmoMOD_Button:StopMovingOrSizing()
		AsmoMODOptionsButton_BeingDragged = false;
	end
end

function AsmoMOD_ToggleDropDown()
	if (AsmoMODOptions:IsVisible()) then
	   AsmoMODOptions:Hide();
	elseif (not AsmoMODOptions:IsVisible()) then
	   AsmoMOD_showMenu();
	end
end

function AsmoMOD_PercentageChanged()
	AsmoMOD_Save.nspercent = this:GetValue();
	nstext:SetText("NSHeal Percent: ".. AsmoMOD_Save.nspercent .. "%");
end

function AsmoMOD_ConserveChanged()
	AsmoMOD_Save.conservepercent = this:GetValue();
	conservetext:SetText("Conserve Percent: ".. AsmoMOD_Save.conservepercent .. "%");
end

function AsmoMOD_ConserveTimeChanged()
	AsmoMOD_Save.conservedelay = this:GetValue();
	conservetimetext:SetText("Conserve Delay: ".. string.format("%0.1f", AsmoMOD_Save.conservedelay) .. "s");
end

function AsmoMOD_RestimeChanged()
	AsmoMOD_Save.reztime = this:GetValue();
	restext:SetText("Ress Delay: ".. AsmoMOD_Save.reztime .. " seconds");
end

function AsmoMOD_SummontimeChanged()
	AsmoMOD_Save.sumtime = this:GetValue();
	summontext:SetText("Summ Delay: ".. AsmoMOD_Save.sumtime .. " seconds");
end

function AsmoMOD_BGtimeChanged()
	AsmoMOD_Save.bgtime = this:GetValue();
	bgtext:SetText("BG Delay: ".. AsmoMOD_Save.bgtime .. " seconds");
end

function AsmoMOD_SwiftPercentChanged()
	AsmoMOD_Save.swiftpercent = this:GetValue();
	swifttext:SetText("Conserve Percent: ".. AsmoMOD_Save.swiftpercent .. "%");
end

function AsmoMOD_EmerPercentChanged()
	AsmoMOD_Save.emerpercent = this:GetValue();
	emertext:SetText("Emergency Percent: ".. AsmoMOD_Save.emerpercent .. "%");
end

-- Various Toggle Functions
function AsmoMOD_RezToggle()
	if ( AsmoMOD_Save.rezenabled ) then
		AsmoMOD_Save.rezenabled = false;
		AsmoMOD_ChatR("Auto Ressurect has been disabled.");
	else
		AsmoMOD_Save.rezenabled = true;
		AsmoMOD_Chat("Auto Ressurect has been enabled.");
	end
end

function AsmoMOD_SummonToggle()
	if ( AsmoMOD_Save.summonenabled ) then
		AsmoMOD_Save.summonenabled = false;
		AsmoMOD_ChatR("Auto Summon has been disabled.");
	else
		AsmoMOD_Save.summonenabled = true;
		AsmoMOD_Chat("Auto Summon has been enabled.");
	end
end

function AsmoMOD_bgreltoggle()
	if ( AsmoMOD_Save.bgrelenabled ) then
		AsmoMOD_Save.bgrelenabled = false;
		AsmoMOD_ChatR("Auto BG Release has been disabled.");
	else
		AsmoMOD_Save.bgrelenabled = true;
		AsmoMOD_Chat("Auto BG Release has been enabled.");
	end
end


function AsmoMOD_bgjointoggle()
	if ( AsmoMOD_Save.bgjoinenabled ) then
		AsmoMOD_Save.bgjoinenabled = false;
		AsmoMOD_ChatR("Auto BG Join has been disabled.");
	else
		AsmoMOD_Save.bgjoinenabled = true;
		AsmoMOD_Chat("Auto BG Join has been enabled.");
	end
end

function AsmoMOD_repairtoggle()
	if ( AsmoMOD_Save.repairenabled ) then
		AsmoMOD_Save.repairenabled = false;
		AsmoMOD_ChatR("Auto Repair has been disabled.");
	else
		AsmoMOD_Save.repairenabled = true;
		AsmoMOD_Chat("Auto Repair has been enabled.");
	end
end

function AsmoMOD_grouptoggle()
	if ( AsmoMOD_Save.groupenabled ) then
		AsmoMOD_Save.groupenabled = false;
		AsmoMOD_ChatR("Auto-accept invites has been disabled.");
	else
		AsmoMOD_Save.groupenabled = true;
		AsmoMOD_Chat("Auto-accept invites has been enabled.");
	end
end

function AsmoMOD_trinkettoggle()
	if ( AsmoMOD_Save.trinketenabled ) then
		AsmoMOD_Save.trinketenabled = false;
		AsmoMOD_ChatR("Auto-break has been totally disabled.");
	else
		AsmoMOD_Save.trinketenabled = true;
		AsmoMOD_Chat("Auto-break has been enabled.");
	end
end

function AsmoMOD_ripostetoggle()
	if ( AsmoMOD_Save.riposteenabled ) then
		AsmoMOD_Save.riposteenabled = false;
		AsmoMOD_ChatR("Auto-use of riposte has been disabled.");
	else
		AsmoMOD_Save.riposteenabled = true;
		AsmoMOD_Chat("Auto-use of riposte has been enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_executetoggle()
	if ( AsmoMOD_Save.executeenabled ) then
		AsmoMOD_Save.executeenabled = false;
		AsmoMOD_ChatR("Auto-use of execute has been disabled.");
	else
		AsmoMOD_Save.executeenabled = true;
		AsmoMOD_Chat("Auto-use of execute has been enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_nshealtoggle()
	if ( AsmoMOD_Save.nsenabled ) then
		AsmoMOD_Save.nsenabled = false;
		AsmoMOD_ChatR("Auto-use of nsheal has been disabled.");
	else
		AsmoMOD_Save.nsenabled = true;
		AsmoMOD_Chat("Auto-use of nsheal has been enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_conservetoggle()
	if ( AsmoMOD_Save.conserveenabled ) then
		AsmoMOD_Save.conserveenabled = false;
		AsmoMOD_ChatR("Auto-cancelling of heals has been disabled.");
	else
		AsmoMOD_Save.conserveenabled = true;
		AsmoMOD_Chat("Auto-cancelling of heals has been enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_herbminetoggle()
	if ( AsmoMOD_Save.herbmineenabled ) then
		AsmoMOD_Save.herbmineenabled = false;
		AsmoMOD_ChatR("Auto-casting of find herbs/minerals has been disabled.");
	else
		AsmoMOD_Save.herbmineenabled = true;
		AsmoMOD_Chat("Auto-casting of find herbs/minerals has been enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_overpowertoggle()
	if ( AsmoMOD_Save.overpowerenabled ) then
		AsmoMOD_Save.overpowerenabled = false;
		AsmoMOD_ChatR("Auto-casting of overpower has been disabled.");
	else
		AsmoMOD_Save.overpowerenabled = true;
		AsmoMOD_Chat("Auto-casting of overpower has been enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_feartoggle()
	if ( AsmoMOD_Save.fearenabled ) then
		AsmoMOD_Save.fearenabled = false;
		AsmoMOD_ChatR("Auto-casting of break effects when you are feared is disabled.");
	else
		AsmoMOD_Save.fearenabled = true;
		AsmoMOD_Chat("Auto-casting of break effects when you are feared is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_entangletoggle()
	if ( AsmoMOD_Save.entangleenabled ) then
		AsmoMOD_Save.entangleenabled = false;
		AsmoMOD_ChatR("Auto-casting of break effects when you are entangled is disabled.");
	else
		AsmoMOD_Save.entangleenabled = true;
		AsmoMOD_Chat("Auto-casting of break effects when you are entangled is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_impairtoggle()
	if ( AsmoMOD_Save.impairenabled ) then
		AsmoMOD_Save.impairenabled = false;
		AsmoMOD_ChatR("Auto-casting of break effects when you are impaired is disabled.");
	else
		AsmoMOD_Save.impairenabled = true;
		AsmoMOD_Chat("Auto-casting of break effects when you are impaired is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_escapetoggle()
	if ( AsmoMOD_Save.escapeenabled ) then
		AsmoMOD_Save.escapeenabled = false;
		AsmoMOD_ChatR("Auto-casting of Escape Artist to break impairment/immobilizing effects is disabled.");
	else
		AsmoMOD_Save.escapeenabled = true;
		AsmoMOD_Chat("Auto-casting of Escape Artist to break impairment/immobilizing effects is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_berserktoggle()
	if ( AsmoMOD_Save.zerkenabled ) then
		AsmoMOD_Save.zerkenabled = false;
		AsmoMOD_ChatR("Auto-casting of Berserker Rage to break fear effects is disabled.");
	else
		AsmoMOD_Save.zerkenabled = true;
		AsmoMOD_Chat("Auto-casting of Berserker Rage to break fear effects is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_wotftoggle()
	if ( AsmoMOD_Save.wotfenabled ) then
		AsmoMOD_Save.wotfenabled = false;
		AsmoMOD_ChatR("Auto-casting of Wotf to break fear effects is disabled.");
	else
		AsmoMOD_Save.wotfenabled = true;
		AsmoMOD_Chat("Auto-casting of Wotf to break fear effects is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_autoswifttoggle()
	if ( AsmoMOD_Save.autoswiftenabled ) then
		AsmoMOD_Save.autoswiftenabled = false;
		AsmoMOD_ChatR("Swiftmend conserve is disabled.");
	else
		AsmoMOD_Save.autoswiftenabled = true;
		AsmoMOD_Chat("Swiftmend conserve is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_emerswifttoggle()
	if ( AsmoMOD_Save.emerswiftenabled ) then
		AsmoMOD_Save.emerswiftenabled = false;
		AsmoMOD_ChatR("Emergency casting of swiftmend if target is below a set hp % is disabled.");
	else
		AsmoMOD_Save.emerswiftenabled = true;
		AsmoMOD_Chat("Emergency casting of swiftmend if target is below a set hp % is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_monitortoggle()
	if ( AsmoMOD_Save.monitorenabled ) then
		AsmoMOD_Save.monitorenabled = false;
		AsmoMOD_ChatR("Swiftmend monitor parsing is disabled.");
	else
		AsmoMOD_Save.monitorenabled = true;
		AsmoMOD_Chat("Swiftmend monitor parsing is enabled.");
		AsmoMOD_Load();
	end
end

function AsmoMOD_playerswfitontoggle()
	if ( AsmoMOD_Save.playerswiftonenabled ) then
		AsmoMOD_Save.playerswiftonenabled = false;
		AsmoMOD_ChatR("Emergency casting of swiftmend on other players is disabled.");
	else
		AsmoMOD_Save.playerswiftonenabled = true;
		AsmoMOD_Chat("Emergency casting of swiftmend on other players is enabled.");
		AsmoMOD_Load();
	end
end

--Timer Functions and Swiftmend Monitor Implimentation
function AsmoMOD_OnUpdate(elapsed)

	-- Mana Conserve Spell Timer
	if((AsmoMOD_Save.conserveenabled) and (manastart ~= 0) and (manastart ~= 999)) then
		local now = GetTime();
		if(now >= manastart) then
			manastart = 0;
		end
	end

	-- Someone has attempted to cast rejuv/regrowth, check to see if the HoT is on the target and if it is,
	-- add it to the swiftmend monitor
	if((UnitIsFriend("target", "player") or (nametoadd == UnitName"player")) and AsmoMOD_Save.monitorenabled and (rejuvcheck or growthcheck)) then
		-- Seamless target switching
		local stayed = 0;

		if(UnitName("target") == nametoadd) then
			stayed = 1;
		else
			TargetByName(nametoadd);
		end

		local k = 1;
		local foundsame = 0;
		while true do
			buff = UnitBuff("target", k);
			if not buff then
      				do break end;
   			end
			if((string.find(buff, "Spell_Nature_Rejuvenation") ~= nil) and rejuvcheck) then
				foundsame = 0;
				for i=0, 4 do
					local labelstring = getglobal("Asmo_ECB_"..i).label;
					if((labelstring ~= nil) and (rejuvtoadd ~= nil)) then
						if((string.find(labelstring, rejuvtoadd) ~= nil) and (string.find(labelstring, "Rejuv") ~= nil)) then
							foundsame = 1;	
							getglobal("Asmo_ECB_"..i).startTime = GetTime();
							getglobal("Asmo_ECB_"..i).active = true;
							getglobal("Asmo_ECB_"..i).endTime = getglobal("Asmo_ECB_"..i).startTime + 12 + FullStormrage;
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetValue(getglobal("Asmo_ECB_"..i).startTime);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetMinMaxValues(getglobal("Asmo_ECB_"..i).startTime, getglobal("Asmo_ECB_"..i).startTime + 12 + FullStormrage);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetStatusBarColor(0, 0, 1, 1);
							getglobal("FauxTargetBtn"..i):SetScale(1);
							getglobal("FauxTargetBtn"..i):Show();
							getglobal("Asmo_ECB_"..i):SetScale(1);
							getglobal("Asmo_ECB_"..i):Show();
						end
					end
				end
				rejuvtoadd = nil;
				rejuvcheck = false;
				if(foundsame == 0) then
					for i=0, 4 do
						if(not getglobal("Asmo_ECB_"..i).active) then
							getglobal("Asmo_ECB_"..i).startTime = GetTime();
							getglobal("Asmo_ECB_"..i).active = true;
							getglobal("Asmo_ECB_"..i).label = UnitName("target") .." - Rejuv";
							getglobal("Asmo_ECB_"..i).type = "rejuv";
							getglobal("Asmo_ECB_"..i).name = UnitName("target");
							getglobal("Asmo_ECB_"..i).endTime = getglobal("Asmo_ECB_"..i).startTime + 12 + FullStormrage;
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetValue(getglobal("Asmo_ECB_"..i).startTime);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetMinMaxValues(getglobal("Asmo_ECB_"..i).startTime, getglobal("Asmo_ECB_"..i).startTime + 12 + FullStormrage);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetStatusBarColor(0, 0, 1, 1);
							getglobal("FauxTargetBtn"..i):SetScale(1);
							getglobal("FauxTargetBtn"..i):Show();
							getglobal("Asmo_ECB_"..i):SetScale(1);
							getglobal("Asmo_ECB_"..i):Show();
							break;
						end
					end
				end
			end

			if((string.find(buff, "Spell_Nature_ResistNature") ~= nil) and growthcheck) then
				foundsame = 0;
				for i=0, 4 do
					local labelstring = getglobal("Asmo_ECB_"..i).label;
					if((labelstring ~= nil) and (regtoadd ~= nil)) then
						if((string.find(labelstring, regtoadd) ~= nil) and (string.find(labelstring, "Regrowth") ~= nil)) then
							foundsame = 1;
							getglobal("Asmo_ECB_"..i).startTime = GetTime();
							getglobal("Asmo_ECB_"..i).active = true;
							getglobal("Asmo_ECB_"..i).endTime = getglobal("Asmo_ECB_"..i).startTime + 21;
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetValue(getglobal("Asmo_ECB_"..i).startTime);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetMinMaxValues(getglobal("Asmo_ECB_"..i).startTime, getglobal("Asmo_ECB_"..i).startTime + 21);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetStatusBarColor(0, 0, 1, 1);
							getglobal("FauxTargetBtn"..i):SetScale(1);
							getglobal("FauxTargetBtn"..i):Show();
							getglobal("Asmo_ECB_"..i):SetScale(1);
							getglobal("Asmo_ECB_"..i):Show();
						end
					end
				end
				regtoadd = nil;
				growthcheck = false;
				if(foundsame == 0) then
					for i=0, 4 do
						if(not getglobal("Asmo_ECB_"..i).active) then
							getglobal("Asmo_ECB_"..i).startTime = GetTime();
							getglobal("Asmo_ECB_"..i).active = true;
							getglobal("Asmo_ECB_"..i).label = UnitName("target") .." - Regrowth";
							getglobal("Asmo_ECB_"..i).type = "regrowth";
							getglobal("Asmo_ECB_"..i).name = UnitName("target");
							getglobal("Asmo_ECB_"..i).endTime = getglobal("Asmo_ECB_"..i).startTime + 21;
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetValue(getglobal("Asmo_ECB_"..i).startTime);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetMinMaxValues(getglobal("Asmo_ECB_"..i).startTime, getglobal("Asmo_ECB_"..i).startTime + 21);
							getglobal("Asmo_ECB_"..i.."_StatusBar"):SetStatusBarColor(0, 0, 1, 1);
							getglobal("FauxTargetBtn"..i):SetScale(1);
							getglobal("FauxTargetBtn"..i):Show();
							getglobal("Asmo_ECB_"..i):SetScale(1);
							getglobal("Asmo_ECB_"..i):Show();
							break;
						end
					end
				end
			end
			k = k + 1;
		end

		if(stayed == 0) then
			TargetLastTarget();
		end
	end
	
	-- Update the monitor's bars constantly for smooth movement
	local index = -1;
	local timeleft = -1;	

	if((AsmoMOD_Save.monitorenabled) and (UnitClass("player") == "Druid")) then
		for i=0, 4 do	
			index = i;		
			local castbari = getglobal("Asmo_ECB_"..i);
			local now = GetTime();
				
			if(castbari.endTime ~= nil) then
				-- Find if unit is in the player's raidgroup
				if(UnitInRaid("player")) then
					for j=1, 40 do
						if(UnitExists("raid" .. j)) then
							-- If Unit is found in raid get hp info
							if(UnitName("raid" .. j) == castbari.name) then
								castbari.hp = (UnitHealth("raid" .. j) / UnitHealthMax("raid" .. j)) * 100;
								castbari.tindex = "raid" .. j;
								if((UnitName("player") ~= UnitName("raid" .. j)) and AsmoMOD_Save.emerswiftenabled and (castbari.hp <= AsmoMOD_Save.emerpercent) and (not AsmoMOD_Save.playerswiftonenabled)) then
									emerlist = index;
								end
							end	
						end
					end
				end

				-- Find if unit is in player's group
				for j=1, 4 do 
					if(UnitExists("party" .. j)) then
						-- If Unit is found in party get hp info
						if(UnitName("party" .. j) ==castbari.name) then
							castbari.hp = (UnitHealth("party" .. j) / UnitHealthMax("party" .. j)) * 100;
							castbari.tindex = "party" .. j;
							if(AsmoMOD_Save.emerswiftenabled and (castbari.hp <= AsmoMOD_Save.emerpercent) and (not AsmoMOD_Save.playerswiftonenabled)) then
								emerlist = index;
							end
						end
						if(UnitName("player") == castbari.name) then
							castbari.hp = (UnitHealth("player") / UnitHealthMax("player")) * 100;
							castbari.tindex = "player";
						end	
					end
				end

				if((castbari.hp ~= nil) and (castbari.type == "regrowth")) then
					castbari.label = castbari.name .."(".. string.format("%3d", castbari.hp) .. "%) - Regrowth";
					local hp = castbari.hp / 100;
					local r, g = 1, 1;
					if ( hp > 0.5 ) then
						r = (1.0 - hp) * 2;
						g = 1.0;
					else
						r = 1.0;
						g = hp * 2;
					end
					if ( r < 0 ) then r = 0; elseif ( r > 1 ) then r = 1; end
					if ( g < 0 ) then g = 0; elseif ( g > 1 ) then g = 1; end
					getglobal("Asmo_ECB_"..i.."_StatusBar"):SetStatusBarColor(r, g, 0, 1);
				elseif(castbari.hp ~= nil) and (castbari.type == "rejuv") then
					castbari.label = castbari.name .."(".. string.format("%3d", castbari.hp) .. "%) - Rejuv";
					local hp = castbari.hp / 100;
					local r, g = 1, 1;
					if ( hp > 0.5 ) then
						r = (1.0 - hp) * 2;
						g = 1.0;
					else
						r = 1.0;
						g = hp * 2;
					end
					if ( r < 0 ) then r = 0; elseif ( r > 1 ) then r = 1; end
					if ( g < 0 ) then g = 0; elseif ( g > 1 ) then g = 1; end
					getglobal("Asmo_ECB_"..i.."_StatusBar"):SetStatusBarColor(r, g, 0, 1);
				end

				-- Update the spark, status bar and label
				local remains = castbari.endTime - now;
				timeleft = remains;

				if((3 >= remains) and (AsmoMOD_Save.autoswiftenabled) and (0 <= remains) and (castbari.hp ~= nil)) then
					if(castbari.hp <= AsmoMOD_Save.swiftpercent) then
						swiftme = i;
					end
				end

				--label
				local sparkPos = ((now - castbari.startTime) / (castbari.endTime - castbari.startTime)) * 195;
				
				getglobal(castbari:GetName() .. "_StatusBar"):SetValue(now);
				getglobal(castbari:GetName() .. "_Text"):SetText( castbari.label );	
				getglobal(castbari:GetName() .. "_StatusBar_Spark"):SetPoint("CENTER", getglobal(castbari:GetName() .. "_StatusBar"), "LEFT", sparkPos, 0);
				getglobal(castbari:GetName() .. "_CastTimeText"):SetText(string.format("%d:%02d", remains / 60, math.mod(remains, 60)));
				
				if (0 >= remains) then
					if(i == emerlist) then
						emerlist = -1;
					elseif(i == swiftme) then
						swiftme = -1;
					end
					getglobal("Asmo_ECB_"..i):Hide();
					getglobal("Asmo_ECB_"..i).type = nil;
					getglobal("Asmo_ECB_"..i).label = nil;
					getglobal("Asmo_ECB_"..i).name = nil;
					getglobal("Asmo_ECB_"..i).hp = nil;
					getglobal("Asmo_ECB_"..i).tindex = nil;
					getglobal("Asmo_ECB_"..i).active = false;
					getglobal("FauxTargetBtn"..i):Hide();
				end	
			end
		end
	end


	-- Timer section that updates once every second
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed;

	-- Auto-accept timers
	if(TimeSinceLastUpdate > AsmoMOD_UpdateInterval) then
		if(resetcounter == 4) then
			rejuvcheck = false;
			growthcheck = false;
			rejuvtoadd = nil;
			regtoadd = nil;
			resetcounter = 0;
		else
			resetcounter = resetcounter + 1;
		end

		-- Timers for auto-accepts
		if(bgtime >= 0) then
			bgtime = bgtime - 1;
			AsmoMODBGTime:SetText(bgtime);
			if(bgtime == 0) then
				bgtime = -1;
				AsmoMODBGChoice:Hide();
				AsmoMOD_bgJoin();
			end
		end
		if(reztime >= 0) then
			reztime = reztime - 1;
			AsmoMODRessTime:SetText(reztime);
			if(reztime == 0) then
				reztime = -1;
				AsmoMODRessChoice:Hide();
				AsmoMOD_Resurrect();
			end
		end
		if(sumtime >= 0) then
			sumtime = sumtime - 1;
			AsmoMODSummTime:SetText(sumtime);
			if(sumtime == 0) then
				sumtime = -1;
				AsmoMODSummChoice:Hide();
				AsmoMOD_Summon();
			end
		end
		
		TimeSinceLastUpdate = 0;
	end
end

-- Save Functions
function AsmoMOD_LoadDefaultVars()
	AsmoMOD_Save = {};
	AsmoMOD_Save.bgrelenabled = true;
	AsmoMOD_Save.bgjoinenabled = true;
	AsmoMOD_Save.repairenabled = true;
	AsmoMOD_Save.rezenabled = true;
	AsmoMOD_Save.summonenabled = true;
	AsmoMOD_Save.groupenabled = true;
	AsmoMOD_Save.trinketenabled = true;
	AsmoMOD_Save.riposteenabled = false;
	AsmoMOD_Save.nsenabled = false;
	if(UnitClass("player") == "Warrior") then
		AsmoMOD_Save.executeenabled = true;
		AsmoMOD_Save.overpowerenabled = true;
	else
		AsmoMOD_Save.executeenabled = false;
		AsmoMOD_Save.overpowerenabled = false;
	end
	AsmoMOD_Save.conserveenabled = false;
	AsmoMOD_Save.herbmineenabled = false;
	AsmoMOD_Save.fearenabled = true;
	AsmoMOD_Save.entangleenabled = true;
	AsmoMOD_Save.impairenabled = true;
	AsmoMOD_Save.escapeenabled = true;
	AsmoMOD_Save.zerkenabled = true;
	AsmoMOD_Save.wotfenabled = true;
	if(UnitClass("player") == "Druid") then
		AsmoMOD_Save.monitorenabled = true;
		AsmoMOD_Save.autoswiftenabled = true;
		AsmoMOD_Save.emerswiftenabled = true;
	else
		AsmoMOD_Save.monitorenabled = false;
		AsmoMOD_Save.autoswiftenabled = false;
		AsmoMOD_Save.emerswiftenabled = false;
	end
	AsmoMOD_Save.playerswiftonenabled = false;
	AsmoMOD_Save.nspercent = 20;
	AsmoMOD_Save.conservepercent = 80;
	AsmoMOD_Save.swiftpercent = 20;
	AsmoMOD_Save.emerpercent = 80;
	AsmoMOD_Save.bgtime = 15;
	AsmoMOD_Save.reztime = 15;
	AsmoMOD_Save.sumtime = 15;
	AsmoMOD_Save.conservedelay = 0.3;
end

-- Swiftmend Functions
function AsmoMOD_IDCheck(idvalue)
	if(idvalue == rejuvAction) then
		if(UnitName("target") == nil) then
			rejuvtoadd = UnitName("player");
			nametoadd = UnitName("player");
		else
			rejuvtoadd = UnitName("target");
			nametoadd = UnitName("target");
		end
		rejuvcheck = true;
		resetcounter = 0;
	end
end

function AsmoMOD_ManualSwift(buttonID)
	if(swiftID ~= 0) then
		duration = GetSpellCooldown(swiftID, 1);
		if(duration == 0) then	
			local ontar = 0;
			if(UnitName("target") == getglobal("Asmo_ECB_"..buttonID).name) then
				ontar = 1;
			else
				TargetByName(getglobal("Asmo_ECB_"..buttonID).name);
			end
			if((UnitName("target") == getglobal("Asmo_ECB_"..buttonID).name) and (not UnitIsDead("target"))) then
				CastSpellByName("Swiftmend");
			end
			if(ontar == 0) then
				TargetLastTarget();
			end
			getglobal("Asmo_ECB_"..buttonID):Hide();
			getglobal("Asmo_ECB_"..buttonID).type = nil;
			getglobal("Asmo_ECB_"..buttonID).label = nil;
			getglobal("Asmo_ECB_"..buttonID).name = nil;
			getglobal("Asmo_ECB_"..buttonID).hp = nil;
			getglobal("Asmo_ECB_"..buttonID).tindex = nil;
			getglobal("Asmo_ECB_"..buttonID).active = false;
			getglobal("FauxTargetBtn"..buttonID):Hide();
		end
	else
		TargetByName(getglobal("Asmo_ECB_"..buttonID).name);
	end
end

function AsmoMOD_SwiftRemove(name, buttonNumber, controldown)
	local nametwice = 0;
	local rejuvNumber;
	local growthNumber;
	if(not controldown) then
		for i=0, 4 do
			local castbari = getglobal("Asmo_ECB_"..i);
			if(castbari.name == name) then
				nametwice = nametwice + 1;
				if(castbari.type ~= nil) then
					if((string.find(castbari.type, "rejuv") ~= nil)) then
						rejuvNumber = i;
					else
						growthNumber = i;
					end
				end
			end
		end
	end
	if(nametwice == 2) then
		if(growthNumber ~= nil and rejuvNumber ~= nil) then
			if(getglobal("Asmo_ECB_"..growthNumber).endTime < getglobal("Asmo_ECB_"..rejuvNumber).endTime) then
				getglobal("Asmo_ECB_"..growthNumber):Hide();
				getglobal("Asmo_ECB_"..growthNumber).type = nil;
				getglobal("Asmo_ECB_"..growthNumber).name = nil;
				getglobal("Asmo_ECB_"..growthNumber).hp = nil;
				getglobal("Asmo_ECB_"..growthNumber).label = nil;
				getglobal("Asmo_ECB_"..growthNumber).tindex = nil;
				getglobal("Asmo_ECB_"..growthNumber).active = false;
				getglobal("FauxTargetBtn"..growthNumber):Hide();
			else
				getglobal("Asmo_ECB_"..rejuvNumber):Hide();
				getglobal("Asmo_ECB_"..rejuvNumber).type = nil;
				getglobal("Asmo_ECB_"..rejuvNumber).name = nil;
				getglobal("Asmo_ECB_"..rejuvNumber).label = nil;
				getglobal("Asmo_ECB_"..rejuvNumber).hp = nil;
				getglobal("Asmo_ECB_"..rejuvNumber).tindex = nil;
				getglobal("Asmo_ECB_"..rejuvNumber).active = false;
				getglobal("FauxTargetBtn"..rejuvNumber):Hide();
			end
		end
	elseif(buttonNumber >= 0) then
		getglobal("Asmo_ECB_"..buttonNumber):Hide();
		getglobal("Asmo_ECB_"..buttonNumber).type = nil;
		getglobal("Asmo_ECB_"..buttonNumber).name = nil;
		getglobal("Asmo_ECB_"..buttonNumber).hp = nil;
		getglobal("Asmo_ECB_"..buttonNumber).tindex = nil;
		getglobal("Asmo_ECB_"..buttonNumber).label = nil;
		getglobal("Asmo_ECB_"..buttonNumber).active = false;
		getglobal("FauxTargetBtn"..buttonNumber):Hide();
	end
end

-- Disable Auto-Join Temporarily
function AsmoMOD_BGJoinDisable()
	bgtime = -1;
end

function AsmoMOD_RessAcceptDisable()
	reztime = -1;
end

function AsmoMOD_SummAcceptDisable()
	sumtime = -1;
end
